#include "stm32f4xx.h"
#include "init.h"

void initialize_system(void)
{
	/* GPIOD init ----------------------------------------------------------------------------*/
	// Reset portu GPID
	RCC->AHB1RSTR |= RCC_AHB1RSTR_GPIODRST;
	RCC->AHB1RSTR &= ~(RCC_AHB1RSTR_GPIODRST);
	// Povoleni hodin pro GPIOD
	RCC->AHB1ENR |= RCC_AHB1ENR_GPIODEN;
	// Nastaveni modu
	//nastaveni pinu 12,13,14 a 15 jako vystupn
	GPIOD->MODER |= (GPIO_MODER_MODER12_0 |
	                 GPIO_MODER_MODER13_0 |
									 GPIO_MODER_MODER14_0 |
									 GPIO_MODER_MODER15_0);
	
	
	
	/* TIM7 init -----------------------------------------------------------------------------*/
	// Rreset casovace TIM6
	RCC->APB1RSTR |= RCC_APB1RSTR_TIM7RST;
	RCC->APB1RSTR &= ~RCC_APB1RSTR_TIM7RST;
     
	// Povolen hodin pro casovac TIM6
	RCC->APB1ENR |= RCC_APB1ENR_TIM7EN;
     
	// Nastaveni
	TIM7->CR1 |= TIM_CR1_ARPE;   // Povoleni prednacteni auto-reload
	TIM7->ARR = 65523;           // Auto-reload hodnota, pri ktere se ma citac resetovat
	TIM7->PSC = 1281;            // Delicka hodinoveho signalu
	TIM7->EGR = TIM_EGR_UG;      // Aktualizace (update event)
	TIM7->SR = 0x0000;           // Vrcen status bitu na log 0
	TIM7->DIER |= TIM_DIER_UIE;	 // povoleni generovni preruseni
	TIM7->CR1 |= TIM_CR1_CEN;    // Spusteni casovace TIM6
	
	/* Iterrupt init -------------------------------------------------------------------------*/
	//NVIC->ISER[1] |= 1<< (TIM7_IRQn-32); // lze i takto
	NVIC->ISER[TIM7_IRQn >> 0x05]  |= (0x01 << (TIM7_IRQn & 0x1F));

	return;
}
