#include <stm32f4xx.h>
#include "init.h"

// Funkce, ktera je primo volana radicem NVIC
void TIM7_IRQHandler(void)
{
	// Je preruseni z UEV casovace TIM7 ?
	if(TIM7->SR & TIM_SR_UIF)    
	{
			if(GPIOD->ODR & GPIO_ODR_ODR_15)
					GPIOD->ODR &= ~GPIO_ODR_ODR_15;
			else
					GPIOD->ODR |= GPIO_ODR_ODR_15;
			TIM7->SR = 0x0000;                   // Vraceni status bitu na log 0
	}
}

int main(void)
{
	// nastaveni HW -> soubor init.c
	initialize_system();
	
	while(1)
		__WFI(); // fuknce CMSIS - vlozi instrukci, ktera ceka dokud nedojde k preruseni
						 //                 -> setreni energii
}
